

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.11.3.1. scorer_tf_at_most &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.11.3.2. scorer_tf_idf" href="scorer_tf_idf.html" />
    <link rel="prev" title="7.11. Scorer" href="../scorer.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/scorers/scorer_tf_at_most.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="scorer_tf_idf.html" title="7.11.3.2. scorer_tf_idf"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="../scorer.html" title="7.11. Scorer"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../scorer.html" accesskey="U"><span class="section-number">7.11. </span>Scorer</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.11.3.1. </span><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="scorer-tf-at-most">
<h1><span class="section-number">7.11.3.1. </span><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code><a class="headerlink" href="#scorer-tf-at-most" title="Permalink to this headline">¶</a></h1>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This scorer is an experimental feature.</p>
</div>
<div class="versionadded">
<p><span class="versionmodified added">New in version 5.0.1.</span></p>
</div>
<div class="section" id="summary">
<h2><span class="section-number">7.11.3.1.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> is a scorer based on TF (term frequency).</p>
<p>TF based scorer includes TF-IDF based scorer has a problem for the
following case:</p>
<p>If document contains many same keywords such as “They are keyword,
keyword, keyword … and keyword”, the document has high score. It’s
not expected. Search engine spammer may use the technique.</p>
<p><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> is a TF based scorer but it can solve the case.</p>
<p><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> limits the maximum score value. It means that
<code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> limits effect of a match.</p>
<p>If document contains many same keywords such as “They are keyword,
keyword, keyword … and keyword”, <code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most(column,</span> <span class="pre">2.0)</span></code>
returns at most <code class="docutils literal notranslate"><span class="pre">2</span></code> as score.</p>
<blockquote id="note">
<div><p>You don’t need to resolve scoring only by score function. Score
function is highly depends on search query. You may be able to use
metadata of matched record.</p>
<p>For example, Google uses <a class="reference external" href="https://en.wikipedia.org/wiki/PageRank">PageRank</a> for scoring. You may be
able to use data type (“title” data are important rather than
“memo” data), tag, geolocation and so on.</p>
<p>Please stop to think about only score function for scoring.</p>
</div></blockquote>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.11.3.1.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p>This scorer has two parameters:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>scorer_tf_at_most(column, max)
scorer_tf_at_most(index, max)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.11.3.1.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>This section describes how to use this scorer.</p>
<p>Here are a schema definition and sample data to show usage.</p>
<p>Sample schema:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Logs TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Logs message COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Terms TABLE_PAT_KEY ShortText \
  --default_tokenizer TokenBigram \
  --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Terms message_index COLUMN_INDEX|WITH_POSITION Logs message
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Sample data:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Logs
[
{&quot;message&quot;: &quot;Notice&quot;},
{&quot;message&quot;: &quot;Notice Notice&quot;},
{&quot;message&quot;: &quot;Notice Notice Notice&quot;},
{&quot;message&quot;: &quot;Notice Notice Notice Notice&quot;},
{&quot;message&quot;: &quot;Notice Notice Notice Notice Notice&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 5]
</pre></div>
</div>
<p>You specify <code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code> in <a class="reference internal" href="../commands/select.html#select-match-columns"><span class="std std-ref">match_columns</span></a> like
the following:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Logs \
  --match_columns &quot;scorer_tf_at_most(message, 3.0)&quot; \
  --query &quot;Notice&quot; \
  --output_columns &quot;message, _score&quot; \
  --sort_keys &quot;-_score&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         5
#       ],
#       [
#         [
#           &quot;message&quot;,
#           &quot;Text&quot;
#         ],
#         [
#           &quot;_score&quot;,
#           &quot;Int32&quot;
#         ]
#       ],
#       [
#         &quot;Notice Notice Notice Notice Notice&quot;,
#         3
#       ],
#       [
#         &quot;Notice Notice Notice Notice&quot;,
#         3
#       ],
#       [
#         &quot;Notice Notice Notice&quot;,
#         3
#       ],
#       [
#         &quot;Notice Notice&quot;,
#         2
#       ],
#       [
#         &quot;Notice&quot;,
#         1
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>If a document has three or more <code class="docutils literal notranslate"><span class="pre">Notice</span></code> terms, its score is <code class="docutils literal notranslate"><span class="pre">3</span></code>.
Because the <code class="docutils literal notranslate"><span class="pre">select</span></code> specify <code class="docutils literal notranslate"><span class="pre">3.0</span></code> as the max score.</p>
<p>If a document has one or two <code class="docutils literal notranslate"><span class="pre">Notice</span></code> terms, its score is <code class="docutils literal notranslate"><span class="pre">1</span></code> or
<code class="docutils literal notranslate"><span class="pre">2</span></code>. Because the score is less than <code class="docutils literal notranslate"><span class="pre">3.0</span></code> specified as the max score.</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.11.3.1.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>This section describes all parameters.</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.11.3.1.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is only one required parameter.</p>
<div class="section" id="column">
<h4><span class="section-number">7.11.3.1.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">column</span></code><a class="headerlink" href="#column" title="Permalink to this headline">¶</a></h4>
<p>The data column that is match target. The data column must be indexed.</p>
</div>
<div class="section" id="index">
<h4><span class="section-number">7.11.3.1.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">index</span></code><a class="headerlink" href="#index" title="Permalink to this headline">¶</a></h4>
<p>The index column to be used for search.</p>
</div>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.11.3.1.4.2. </span>Optional parameters<a class="headerlink" href="#optional-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is no optional parameter.</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.11.3.1.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p>This scorer returns score as <a class="reference internal" href="../types.html#builtin-type-float"><span class="std std-ref">Float32</span></a>.</p>
<p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> returns <code class="docutils literal notranslate"><span class="pre">_score</span></code> as <code class="docutils literal notranslate"><span class="pre">Int32</span></code> not
<code class="docutils literal notranslate"><span class="pre">Float</span></code>. Because it casts to <code class="docutils literal notranslate"><span class="pre">Int32</span></code> from <code class="docutils literal notranslate"><span class="pre">Float</span></code> for keeping
backward compatibility.</p>
<p>Score is computed as TF with limitation.</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.11.3.1.6. </span>See also<a class="headerlink" href="#see-also" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../scorer.html"><span class="doc">Scorer</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.11.3.1. <code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.11.3.1.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.11.3.1.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.11.3.1.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.11.3.1.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.11.3.1.4.1. Required parameters</a><ul>
<li><a class="reference internal" href="#column">7.11.3.1.4.1.1. <code class="docutils literal notranslate"><span class="pre">column</span></code></a></li>
<li><a class="reference internal" href="#index">7.11.3.1.4.1.2. <code class="docutils literal notranslate"><span class="pre">index</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.11.3.1.4.2. Optional parameters</a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.11.3.1.5. Return value</a></li>
<li><a class="reference internal" href="#see-also">7.11.3.1.6. See also</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="../scorer.html"
                        title="previous chapter"><span class="section-number">7.11. </span>Scorer</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="scorer_tf_idf.html"
                        title="next chapter"><span class="section-number">7.11.3.2. </span><code class="docutils literal notranslate"><span class="pre">scorer_tf_idf</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="scorer_tf_idf.html" title="7.11.3.2. scorer_tf_idf"
             >next</a> |</li>
        <li class="right" >
          <a href="../scorer.html" title="7.11. Scorer"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../scorer.html" ><span class="section-number">7.11. </span>Scorer</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.11.3.1. </span><code class="docutils literal notranslate"><span class="pre">scorer_tf_at_most</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>